## ros-iron-tricycle-controller 3.15.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(tricycle_controller LANGUAGES CXX)

if(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
  add_compile_options(-Wall -Wextra -Wpedantic -Wconversion)
endif()

set(THIS_PACKAGE_INCLUDE_DEPENDS
  ackermann_msgs
  builtin_interfaces
  controller_interface
  geometry_msgs
  hardware_interface
  nav_msgs
  pluginlib
  rclcpp
  rclcpp_lifecycle
  rcpputils
  realtime_tools
  std_srvs
  tf2
  tf2_msgs
)

find_package(ament_cmake REQUIRED)
find_package(backward_ros REQUIRED)
foreach(Dependency IN ITEMS ${THIS_PACKAGE_INCLUDE_DEPENDS})
  find_package(${Dependency} REQUIRED)
endforeach()

add_library(tricycle_controller SHARED
  src/tricycle_controller.cpp
  src/odometry.cpp
  src/traction_limiter.cpp
  src/steering_limiter.cpp
)
target_compile_features(tricycle_controller PUBLIC cxx_std_17)
target_include_directories(tricycle_controller PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include/tricycle_controller>
)
ament_target_dependencies(tricycle_controller PUBLIC ${THIS_PACKAGE_INCLUDE_DEPENDS})

pluginlib_export_plugin_description_file(controller_interface tricycle_controller.xml)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(controller_manager REQUIRED)
  find_package(ros2_control_test_assets REQUIRED)

  ament_add_gmock(test_tricycle_controller
    test/test_tricycle_controller.cpp
    ENV config_file=${CMAKE_CURRENT_SOURCE_DIR}/test/config/test_tricycle_controller.yaml)
  target_link_libraries(test_tricycle_controller
    tricycle_controller
  )
  ament_target_dependencies(test_tricycle_controller
    geometry_msgs
    hardware_interface
    nav_msgs
    rclcpp
    rclcpp_lifecycle
    realtime_tools
    tf2
    tf2_msgs
  )

  ament_add_gmock(test_load_tricycle_controller
    test/test_load_tricycle_controller.cpp
  )
  target_link_libraries(test_load_tricycle_controller
    tricycle_controller
  )
  ament_target_dependencies(test_load_tricycle_controller
    controller_manager
    ros2_control_test_assets
  )
endif()

install(
  DIRECTORY include/
  DESTINATION include/tricycle_controller
)
install(
  TARGETS
    tricycle_controller
  EXPORT export_tricycle_controller
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

ament_export_targets(export_tricycle_controller HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})
ament_package()

=== debian/changelog ===
ros-iron-tricycle-controller (3.15.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 Sep 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.14.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Aug 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.13.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 03 Aug 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.12.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Jul 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.11.0-1jammy) jammy; urgency=high

  * Added -Wconversion flag and fix warnings (#667 <https://github.com/ros-controls/ros2_controllers/issues/667>)
  * Contributors: gwalck

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 23 Jun 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.10.1-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 05 Jun 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.10.0-1jammy) jammy; urgency=high

  * enable ReflowComments to also use ColumnLimit on comments (#625 <https://github.com/ros-controls/ros2_controllers/issues/625>)
  * Contributors: Sai Kishor Kothakota

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 03 Jun 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.9.0-1jammy) jammy; urgency=high

  * Use branch name substitution for all links (#618 <https://github.com/ros-controls/ros2_controllers/issues/618>)
  * Fix github links on control.ros.org (#604 <https://github.com/ros-controls/ros2_controllers/issues/604>)
  * Contributors: Christoph Fröhlich

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 27 May 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.8.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 13 May 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.7.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 01 May 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.6.0-1jammy) jammy; urgency=high

  * Renovate load controller tests (#569 <https://github.com/ros-controls/ros2_controllers/issues/569>)
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 28 Apr 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.5.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 13 Apr 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.4.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 01 Apr 2023 23:00:00 -0000

ros-iron-tricycle-controller (3.3.0-1jammy) jammy; urgency=high

  * Use std::clamp instead of rcppmath::clamp (#540 <https://github.com/ros-controls/ros2_controllers/issues/540>)
  * Remove publish_rate argument (#529 <https://github.com/ros-controls/ros2_controllers/issues/529>)
  * Contributors: Christoph Fröhlich, Tony Najjar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 07 Mar 2023 00:00:00 -0000

ros-iron-tricycle-controller (3.2.0-1jammy) jammy; urgency=high

  * Fix overriding of install (#510 <https://github.com/ros-controls/ros2_controllers/issues/510>)
  * Contributors: Tyler Weaver, Chris Thrasher

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 10 Feb 2023 00:00:00 -0000

ros-iron-tricycle-controller (3.1.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 26 Jan 2023 00:00:00 -0000

ros-iron-tricycle-controller (3.0.0-1jammy) jammy; urgency=high

  * Add backward_ros to all controllers (#489 <https://github.com/ros-controls/ros2_controllers/issues/489>)
  * Fix deprecation warnings when compiling (#478 <https://github.com/ros-controls/ros2_controllers/issues/478>)
  * Contributors: Bence Magyar, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 19 Jan 2023 00:00:00 -0000

ros-iron-tricycle-controller (2.15.0-1jammy) jammy; urgency=high

  * [TricycleController] Removed “publish period” functionality ⏱ #abi-break #behavior-break (#468 <https://github.com/ros-controls/ros2_controllers/issues/468>)
  * Contributors: Robotgir, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 06 Dec 2022 00:00:00 -0000

ros-iron-tricycle-controller (2.14.0-1jammy) jammy; urgency=high

  * Include <string> to fix compilation error on macOS (#467 <https://github.com/ros-controls/ros2_controllers/issues/467>)
  * Contributors: light-tech

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 18 Nov 2022 00:00:00 -0000

ros-iron-tricycle-controller (2.13.0-1jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 04 Oct 2022 23:00:00 -0000

ros-iron-tricycle-controller (2.12.0-1jammy) jammy; urgency=high

  * Fix formatting CI job (#418 <https://github.com/ros-controls/ros2_controllers/issues/418>)
  * Fix formatting because pre-commit was not running on CI for some time. (#409 <https://github.com/ros-controls/ros2_controllers/issues/409>)
  * Contributors: Denis Štogl, Tyler Weaver

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 31 Aug 2022 23:00:00 -0000

ros-iron-tricycle-controller (2.11.0-1jammy) jammy; urgency=high

  * Tricycle controller (#345 <https://github.com/ros-controls/ros2_controllers/issues/345>)
  * Contributors: Bence Magyar, Tony Najjar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 03 Aug 2022 23:00:00 -0000

=== debian/control ===
Source: ros-iron-tricycle-controller
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ackermann-msgs, ros-iron-ament-cmake, ros-iron-ament-cmake-gmock <!nocheck>, ros-iron-backward-ros, ros-iron-builtin-interfaces, ros-iron-controller-interface, ros-iron-controller-manager <!nocheck>, ros-iron-geometry-msgs, ros-iron-hardware-interface, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-lifecycle, ros-iron-rcpputils, ros-iron-realtime-tools, ros-iron-ros2-control-test-assets <!nocheck>, ros-iron-std-srvs, ros-iron-tf2, ros-iron-tf2-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-tricycle-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-ackermann-msgs, ros-iron-backward-ros, ros-iron-builtin-interfaces, ros-iron-controller-interface, ros-iron-geometry-msgs, ros-iron-hardware-interface, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-lifecycle, ros-iron-rcpputils, ros-iron-realtime-tools, ros-iron-std-srvs, ros-iron-tf2, ros-iron-tf2-msgs, ros-iron-ros-workspace
Description: Controller for a tricycle drive mobile base

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-tricycle-controller//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
